'use strict';

angular.module('smaApp.view-baby-profile', [])

.config(function ($stateProvider, $urlRouterProvider) {
    $stateProvider
        .state('app.profile', {
            url: '/profile',
            views: {
                'menuContent': {
                    templateUrl: 'view-baby-profile/view-baby-profile.html',
                    controller: 'ProfileController'
                }
            }
        })
})


.controller('ProfileController', ['$scope', '$http', '$state', '$ionicPopup', '$ionicPopover', 'ionicDatePicker', function ($scope, $http, $state, $ionicPopup, $ionicPopover, ionicDatePicker) {

    $scope.babyName = userBabyName;
    $scope.babyDOB = userBabyDOB;
    $scope.thisWeek = systemCalculatedWeek;
    $scope.displayedWeek = systemCalculatedWeek;
    updateHighlight(systemCalculatedWeek);

    $scope.unsavedChanges = false;
    $scope.unsavedChangesWeek = false;
    $scope.unsavedChangesDOB = false;
    $scope.unsavedChangesName = false;

    $scope.weekAboveTwentySix = false;
    $scope.pageLoaded = false;

    if(systemCalculatedWeek == 27)
    {
        $scope.weekAboveTwentySix = true;
    }

    $scope.$on('$ionicView.enter', function (e) {

        if(systemCalculatedWeek == 27)
        {
            $scope.weekAboveTwentySix = true;
        }
        
        $scope.unsavedChanges = false;
        $scope.unsavedChangesWeek = false;
        $scope.unsavedChangesDOB = false;
        $scope.unsavedChangesName = false;
        
        if (typeof window.analytics !== undefined) {
            window.analytics.trackView('Baby Settings');
        }

        $scope.pageLoaded = true;

    });

    $scope.updateProfile = function(){
        if($scope.unsavedChanges)
        {
            var name = document.querySelector('#profileBabyName').value;
            var dob = $scope.babyDOB || userBabyDOB;
            $scope.unsavedChanges = false;
            $scope.updateBabyProfile(name, dob, $scope.displayedWeek);
        }
    }

    $scope.babyNameEntered = function(){
        
        if(document.querySelector('#profileBabyName').value!="")
        {
            $scope.unsavedChanges = true;
            $scope.unsavedChangesName = true;
        }
        else
        {
            $scope.unsavedChanges = false;
            $scope.unsavedChangesName = false;
        }

    }

    $scope.reduceWeekNumber = function(){
        if($scope.displayedWeek>1)
        {
            $scope.unsavedChanges = true;
            $scope.unsavedChangesWeek = true;
            $scope.displayedWeek--;
            updateHighlight($scope.displayedWeek);
        }

        if($scope.displayedWeek == systemCalculatedWeek)
        {
            $scope.unsavedChanges = false;
            $scope.unsavedChangesWeek = false;
        }
    }

    $scope.increaseWeekNumber = function(){
        if($scope.displayedWeek<27)
        {
            $scope.unsavedChanges = true;
            $scope.unsavedChangesWeek = true;
            $scope.displayedWeek++;
            updateHighlight($scope.displayedWeek);
        }

        if($scope.displayedWeek == systemCalculatedWeek)
        {
            $scope.unsavedChanges = false;
            $scope.unsavedChangesWeek = false;
        }
    }

    function updateHighlight(w)
    {
        $scope.weekHighlight = weekHighlights[w].replace(/babyname/gi, userBabyName);

        if($scope.displayedWeek == 27)
        {
            $scope.weekAboveTwentySix = true;
        }
        else
        {
            $scope.weekAboveTwentySix = false;
        }
    }

}])