'use strict';

angular.module('smaApp.view-favourites', [])

.config(function ($stateProvider, $urlRouterProvider) {
    $stateProvider
        .state('app.favourites', {
            url: '/favourites',
            views: {
                'menuContent': {
                    templateUrl: 'view-favourites/view-favourites.html',
                    controller: 'FavouritesController'
                }
            }
        })
})


.controller('FavouritesController', ['$scope', '$http', '$state', '$ionicPopup', '$ionicPopover', function ($scope, $http, $state, $ionicPopup,$ionicPopover) {
    
    $scope.filteredRecipes = recipes; // all recipe
    $scope.popover;
    
    $scope.favRecipes = favouriteRecipes;
    $scope.shopping = shoppingList;
    var selectedRecipeId;
    
    $scope.$on('$ionicView.enter', function(e) {
        
        if(typeof window.analytics !== undefined)
        {
            window.analytics.trackView('Favourites');
        }

    });
    
    $ionicPopover.fromTemplateUrl('templates/popover.html', {
            scope: $scope,
          }).then(function(popover) {
            $scope.popover = popover;
    });
    
    $scope.applyFilter = function(menuItem){  

            for(var f = 0;f<favouriteRecipes.length;f++) // 
            {
                if((menuItem.ArticleId==favouriteRecipes[f].aId)&&(favouriteRecipes[f].fav))
                {
                    return true;
                }

            }    
            
            return false;
    }

    $scope.showRecipe = function (p) {
        
        // currentRecipe = p;
        // $state.go('app.recipe-details');


        if(registered)
        {
            currentRecipe = p;
            $state.go('app.recipe-details');
        }
        else
        {
            $scope.showPopUp('favourites');
        }

    }
    
    $scope.checkFavourite = function(aId)
    {
        for(var f = 0;f<favouriteRecipes.length;f++) // check all favs
        {
            if((aId==favouriteRecipes[f].aId)&&(favouriteRecipes[f].fav))
            {
               return true;
            }
        }   
        
        return false;
    }
    
    $scope.removeFavourite = function (aId)
    {
        selectedRecipeId = aId;
        for(var f = 0;f<favouriteRecipes.length;f++) // check all favs
        {
            if(aId==favouriteRecipes[f].aId)
            {
                if(favouriteRecipes[f].fav)
                    favouriteRecipes[f].fav=false;
            }

        } 
        
        $scope.updateData();
        // var alert = $ionicPopup.alert({
               
        //        title:'Remove favourite',
        //        template:'Are you sure you would like to remove this recipe from your favourites?',
        //        buttons: [
        //            {
        //                text:'Yes please',
        //                onTap: function(e)
        //                {
        //                    for(var f = 0;f<favouriteRecipes.length;f++) // check all favs
        //                     {
        //                         if(aId==favouriteRecipes[f].aId)
        //                         {
        //                             if(favouriteRecipes[f].fav)
        //                                 favouriteRecipes[f].fav=false;
        //                         }

        //                     } 
                           
        //                     $scope.updateData();
                           
        //                    return true;
        //                }
        //            },
        //            {
        //                text:'No thanks',
        //                onTap: function(e)
        //                {
        //                    return true;
        //                }
        //            }
        //        ]
        //    });
    
    }
    
    // MEAL PLANNER
    
    $scope.addToPlanner = function(p)
    {
        currentRecipe = p;
        dynamicallyAddedSlot = true;
        $state.go('app.your-plans');
    }
    
    // SHOPPING
    
    $scope.addFavouriteToShoppingList = function(p)
    {
        currentRecipe = p;
        $scope.addToShoppingList();
        
    }
    
    function alertDismissed()
    {
        
    }

    
}])