'use strict';

angular.module('smaApp.view-form', [])

.config(function ($stateProvider, $urlRouterProvider) {
    $stateProvider
        .state('form', {
            url: '/form',
            templateUrl: "view-form/view-form.html",
            controller: 'FormCtrl'
        })
})


.controller('FormCtrl', ['$scope', '$http', '$state', '$ionicPopup', '$ionicPopover', 'ionicDatePicker', function ($scope, $http, $state, $ionicPopup, $ionicPopover, ionicDatePicker) {

    $scope.userBabyDOB = userBabyDOB;
    $scope.dobValidation = false;
    $scope.emailValidation = false;
    $scope.firstNameValidation = false;
    var consented = false;
    var consenting = false;

    $scope.consentChanged =function(c){
        
        consented = true;
        if(c==1)
        {
            consenting=false;
            document.querySelector('.form-main').style.display = 'none';
            document.querySelector('.form-main').style.opacity = 0;
            document.querySelector('#form-submit-button').innerHTML = "Let's wean!";
            // $scope.emailValidation = false;
            // $scope.firstNameValidation = false;
            $scope.FormEnabled = true;
        }
        else
        {
            consenting=true;
            document.querySelector('.form-main').style.display = 'block';
            document.querySelector('.form-main').style.opacity = 1;
            document.querySelector('#form-submit-button').innerHTML = "Submit & let's wean!";
            $scope.FormEnabled = false;
        }
        //checkSubmitReady();
    }

    $scope.validateForm = function () {
        

      if(consenting)
      {
      

        if ($('#signup-firstName').val() == "") {
          $scope.firstNameValidation = true;
        } else {
          $scope.firstNameValidation = false;
            
          userFirstName = $('#signup-firstName').val();
        }
        
        if (isEmail(document.getElementById('signup-email').value))
        {
            $scope.emailValidation = false;
        }
        else {
            $scope.emailValidation = true;
        }

        if ((!$scope.emailValidation) && (!$scope.dobValidation) && (!$scope.firstNameValidation) ) {
          submitForm();
        }

      }
      else if((consented)&&(!consenting))
      {
          registered = true;
          updateUserData();
          $state.go('app.welcome');
      }

    }

    // $scope.submitForm = function(){
    //   // registered = true;
    //   // updateUserData();
    //   // $state.go('app.welcome');
    // }

    function submitForm(){

      if(legacyUser)
      {
        registered = true;
        legacyUser = false;
        updateUserData();
        $state.go('app.welcome-back');
      }
      else
      {
        // registered = true;
        // updateUserData();
        // $state.go('app.welcome');
        
        $scope.submitSignup();
      }

    }

    function checkSubmitReady(){
        
        if ((!$scope.emailValidation) && (!$scope.dobValidation) && (!$scope.firstNameValidation) ) {
          $scope.FormEnabled = true;
        }
        else
        {
          $scope.FormEnabled = false;
        }
    }

    $scope.openDatePicker = function () {

        var ipObj1 = {
            callback: function (val) { //Mandatory

                babyDOB = new Date(val);
                //console.log('Return value from the datepicker popup is : ' + val, babyDOB);
                document.getElementById('dob').value = babyDOB.toDateString()
                // if ($('#dob').val() == "") {
                //     $scope.dobValidation = true;
                // } else {
                //     $scope.dobValidation = false;
                // }
            },
            from: new Date(2014, 12, 1), //Optional
            to: new Date(), //Optional
            inputDate: babyDOB, //Optional
            mondayFirst: false, //Optional
            disableWeekdays: [], //Optional
            closeOnSelect: false, //Optional
            templateType: 'modal' //Optional
            
            
        };

        ionicDatePicker.openDatePicker(ipObj1);
    };

    $scope.emailEntered = function(){
        
        if (isEmail(document.getElementById('signup-email').value))
        {
            $scope.emailValidation = false;
        }
        else {
            $scope.emailValidation = true;
        }

        checkSubmitReady();
    }

    $scope.firstNameEntered = function(){

        if (document.getElementById('signup-firstName').value == "") {
          $scope.firstNameValidation = true;
        } else {
            $scope.firstNameValidation = false;
        }
        
        checkSubmitReady();
    }

    $scope.submitSignup = function () {
        
        if(checkConnection())
        {
          $scope.FormEnabled = false;
          firebaseSignup();
        }
        else
        {
          var alert = navigator.notification.alert(
            'Your device appears to be offline. To signup you need to be connected to the internet. Please try again when you are back online', // message
            alertDismissed, // callback
            'No internet connection', // title
            'Ok' // buttonName
          );
        }

    }

    $scope.openPrivacyPolicy = function()
    {
        var link = window.open('http://www.immediate.co.uk/privacy-policy/', '_system', 'location=yes');
    }

    function checkConnection(){
      if(window.Connection) {
            if(navigator.connection.type == Connection.NONE) {
              return false;
            }
            else
            {
              return true;
            }
        }
        else
        {
            if (navigator.onLine) {
                return true;
            } else {
                return false;
            }   

        }
    }

    function firebaseSignup()
    {
      var signupDate = (new Date()).toDateString();

      firebase.auth().createUserWithEmailAndPassword(document.getElementById('signup-email').value, standardPassword)
      .then(function(newUserData) {
        // console.log("User " + newUserData.uid + " created successfully!");
        var listToUse = calculateList(newUserData.uid);
        var profileListRef = firebase.database().ref(listToUse);
        // alert(userFirstName);
        // alert(babyDOB.toDateString());
        // alert(userPlatform);
        // alert(signupDate);
        // var newProfileRef = profileListRef.push();
        profileListRef.set({
          'user_id': newUserData.uid,
          'email': document.getElementById('signup-email').value,
          'first-name': userFirstName,
          'baby-dob': babyDOB.toDateString(),
          'platform': 'android',
          'signup-date': signupDate
        });
    }).then(function(){
      // close the form
      updateSuccess();
    }).catch(function(error) {
        // Handle Errors here.
        var errorCode = error.code;
        var errorMessage = error.message;
        if (errorCode == 'auth/weak-password') {
          alert('The password is too weak.');
        } 
        else if (errorCode == 'auth/email-already-in-use') {

          var alert = navigator.notification.alert(
            "Welcome back, you're all set to start using our app again!", // message
            alertDismissed, // callback
            'Thank You', // title
            'Ok' // buttonName
          );

          // $scope.closePopUp();
          // $scope.FormEnabled = true;
          // registered = true;
          // $scope.updateData();

          registered = true;
          updateUserData();
          $state.go('app.welcome-back');

        }
        else {
          console.log(errorMessage);
        }
        console.log(error);
    });
    }
    
    function updateSuccess() {

      var alert = navigator.notification.alert(
          "Thanks for signing up, you're all set to start using our app!", // message
          alertDismissed, // callback
          'Thank You', // title
          'Ok' // buttonName
      );

      // $scope.closePopUp();
      // $scope.FormEnabled = true;
      // registered = true;
      // $scope.updateData();

      registered = true;
      updateUserData();
      $state.go('app.welcome');
      
      if(typeof window.analytics !== undefined)
      {
          window.analytics.trackEvent('Signup', 'Completed', signUpPage);
      }
  }

  function getWeek(d) {
    var date = d;
    date.setHours(0, 0, 0, 0);
    // Thursday in current week decides the year.
    date.setDate(date.getDate() + 3 - (date.getDay() + 6) % 7);
    // January 4 is always in week 1.
    var week1 = new Date(date.getFullYear(), 0, 4);
    // Adjust to Thursday in week 1 and count number of weeks from date to week1.
    return 1 + Math.round(((date.getTime() - week1.getTime()) / 86400000 - 3 + (week1.getDay() + 6) % 7) / 7);
  }

  function calculateList(uid){

    var theDate = new Date()
    var tdotw = theDate.getDay();
    var fy = theDate.getFullYear();
    var w = getWeek(theDate);
    var nw;

    if(tdotw === 5 ||
      tdotw === 6 ||
      tdotw === 0){ // current week
      
      nw = w
    }
    else {  // week before

      if(w==1)
      {
        nw=52;
        fy=fy-1;
      }
      else
      {
        nw = w-1;
      }
    }

    var listName = 'signup_list_new/signups-week'+nw+'-'+fy+'/'+uid;

    if(isNaN(w))
    {
      return 'signup_list_error/'+uid;
    }
    else
    {
      return listName;
    }

  }
}])