'use strict';

angular.module('smaApp.view-home', [])

.config(function ($stateProvider, $urlRouterProvider) {
    $stateProvider
        .state('app.home', {
              url: '/home',
              views: {
                'menuContent': {
                  templateUrl: 'view-home/view-home.html',
                  controller: 'HomeController'
                }
              }
        });
})


.controller('HomeController', ['$scope', '$http', '$state', '$ionicPopup', '$ionicPopover', function ($scope, $http, $state, $ionicPopup,$ionicPopover) {

    $scope.babyName = userBabyName;
    $scope.favRecipes = favouriteRecipes;
    $scope.filteredRecipes = recipes;
    $scope.thisWeek = systemCalculatedWeek;
    $scope.thisWeeksRecipes;
    $scope.adEnvironment = env;
    $scope.thisWeekMinus1;
    $scope.thisWeekMinus2;
    $scope.thisWeekPlus1;
    $scope.thisWeekPlus2;
    $scope.weekAboveTwentySix = false;
                        
    setWeekWidgetNumbers();
        
    $scope.$on('$ionicView.enter', function(e) {
              
        setWeekWidgetNumbers();

        // get recipes in the order Susie needs them:
        var theWeeksRecipes = weekData[$scope.thisWeek].RecipeList;
        $scope.thisWeeksRecipes=[];

        // $scope.thisWeeksRecipes = theWeeksRecipes;
        
        for(var x=0;x<theWeeksRecipes.length;x++)
        {
            for(var i=0;i<recipes.length;i++)
            {
                if(theWeeksRecipes[x]==recipes[i].ArticleId)
                {
                    $scope.thisWeeksRecipes.push(recipes[i]);
                }
            }
        }

        if(typeof window.analytics !== undefined)
        {
            window.analytics.trackView('Home Screen');
        }

        if(filteredRecipes.length<1)
        {
            $scope.noResults = true;
            filteredRecipes = recipes;
        }

    });

    $scope.weekFilter = function (item){
        
        $scope.theWeeksRecipes = weekData[$scope.thisWeek].RecipeList;
        
        for(var i=0;i<$scope.theWeeksRecipes.length;i++)
        {
            if($scope.theWeeksRecipes[i]==item.ArticleId)
            {
                return true;
            }
        }
        
        return false;
    }

    $scope.openGuideLink = function(url)
    {
        var u = 'app.'+url;
        $state.go(u);
    }

    $scope.visitWeekPage = function(){

        viewingGuides = false;

        if(systemCalculatedWeek>0)
        {
            currentWeekSelected = systemCalculatedWeek;
            $state.go('app.week-planner-week');
        }

    }

    $scope.goToGuides = function(){
        $state.go('app.weaning-guide');
    }

    $scope.goToWeeks = function(){
        $state.go('app.all-weeks');
    }

    $scope.goToPlannerWeeks = function(){
        $state.go('app.all-planner-weeks');
    }

    $scope.goToYourPlans = function(){
        $state.go('app.your-plans');
    }

    $scope.goWrong = function(){
        $state.go('app.if-things-go-wrong');
    }

    $scope.goToPortion = function(){
        $state.go('app.portion-size-guide');
    }

    $scope.goToTips = function(){
        $state.go('app.sma-help');
    }

    $scope.goToShopping = function(){
        $state.go('app.shopping');
    }

    $scope.goToAllPlanners = function(){
        $state.go('app.planners');
    }

    function setWeekWidgetNumbers(){
        $scope.babyName = userBabyName;
        $scope.thisWeek = systemCalculatedWeek;
        $scope.weekHighlight = weekHighlights[systemCalculatedWeek].replace(/babyname/gi, userBabyName);  
        $scope.theWeek = weekData[systemCalculatedWeek];
        $scope.theWeeksMeals = weekData[systemCalculatedWeek].MealPlanner;
        $scope.theWeeksLinks = $scope.theWeek.GuideContent;
        console.dir('weeks');     
        console.dir($scope.theWeeksLinks); 
        $scope.weekAboveTwentySix = false;
        
        if(systemCalculatedWeek == 2)
        {
            $scope.thisWeekMinus2 = "";
        }

        if(systemCalculatedWeek == 25)
        {
            $scope.thisWeekPlus2 = "";
        }


        if(systemCalculatedWeek > 1)
        {
            $scope.thisWeekMinus1 = systemCalculatedWeek-1;
        }
        else {
            $scope.thisWeekMinus1 = "";
            $scope.thisWeekMinus2 = "";
        }

        if(systemCalculatedWeek > 2)
        {
            $scope.thisWeekMinus2 = systemCalculatedWeek-2;
        }

        if(systemCalculatedWeek < 26)
        {
            $scope.thisWeekPlus1 = systemCalculatedWeek+1;
        }
        else
        {
            $scope.thisWeekPlus1 = "";
            $scope.thisWeekPlus2 = "";
        }

        if(systemCalculatedWeek < 25)
        {
            $scope.thisWeekPlus2 = systemCalculatedWeek+2;
        }

        if(systemCalculatedWeek==0)
        {
            // $scope.$apply(function(){
                 $scope.weekAboveZero = false;
            // });
        }
        else
        {
            // $scope.$apply(function(){
                 $scope.weekAboveZero = true;
            // });
        }

        if(systemCalculatedWeek == 27)
        {
            $scope.weekAboveTwentySix = true;
        }

        // $scope.$apply(function(){
        //     $scope.weekAboveZero = $scope.weekAboveZero;
        // });

        //alert('state changed')
    }

    $scope.noAdReturned = function()
    {
      console.log('NO AD RETURNED!!');
    }

    $scope.showRecipe = function (p) {
        
    //   if(registered)
    //   {
           currentRecipe = p;
           $state.go('app.recipe-details');
    //   }
    //   else
    //   {
    //      $scope.showPopUp('recipe list');
    //  }
  }
  
  $scope.favouriteRecipe = function (e,aId) {
      
      // check status
      if($scope.checkFavourite(aId))
      {
          removeFavourite(aId);
      }
      else
      {
          addFavourite(aId);
      }
      
      $scope.updateData();
  }
  
  
  $scope.checkFavourite = function(aId)
  {
      for(var f = 0;f<$scope.favRecipes.length;f++) // check all favs
      {
          if((aId==$scope.favRecipes[f].aId)&&($scope.favRecipes[f].fav))
          {
             return true;
          }
        
      }   
      
      return false;
  }

  $scope.applyFilter = function(menuItem){  

        for(var f = 0;f<favouriteRecipes.length;f++) // 
        {
            if((menuItem.ArticleId==favouriteRecipes[f].aId)&&(favouriteRecipes[f].fav))
            {
                return true;
            }

        }    
    
        return false;
    }
  
  function removeFavourite(aId)
  {
      for(var f = 0;f<favouriteRecipes.length;f++) // check all favs
      {
          if(aId==favouriteRecipes[f].aId)
          {
              if(favouriteRecipes[f].fav)
                  favouriteRecipes[f].fav=false;
          }
        
      } 
  }
  
  function addFavourite(aId)
  {
      for(var f = 0;f<favouriteRecipes.length;f++) // check all favs
      {
          if(aId==favouriteRecipes[f].aId)
          {
              if(!favouriteRecipes[f].fav)
                  favouriteRecipes[f].fav=true;
          }
      } 
      
      if(typeof window.analytics !== undefined)
      {
          window.analytics.trackEvent('Added', 'Favourites', aId);
          
      }
  }

  function alertDismissed() {

  }
    
}])