'use strict';

angular.module('smaApp.view-meal-planners', [])

.config(function ($stateProvider, $urlRouterProvider) {
    $stateProvider
        .state('app.planners', {
            url: '/planners',
            views: {
                'menuContent': {
                    templateUrl: 'view-meal-planners/view-meal-planners.html',
                    controller: 'PlannersController'
                }
            }
        })
    .state('app.your-plans', {
            url: '/your-plans',
            views: {
                'menuContent': {
                    templateUrl: 'view-meal-planners/view-your-plans.html',
                    controller: 'PlannerController'
                }
            }
        })
    .state('app.your-plan', {
            url: '/your-plan',
            views: {
                'menuContent': {
                    templateUrl: 'view-meal-planners/view-your-plan.html',
                    controller: 'PlanController'
                }
            }
        })
        .state('app.plan-recipes', {
            url: '/plan-recipes',
            views: {
                'menuContent': {
                    templateUrl: 'view-meal-planners/view-plan-recipes.html',
                    controller: 'PlanRecipesController'
                }
            }
        })
})



.controller('PlannersController', ['$scope', '$http', '$state', '$ionicPopup', function ($scope, $http, $state, $ionicPopup) {

    dynamicallyAddedSlot = false;
    
    $scope.$on('$ionicView.enter', function(e) {
        
        if(typeof window.analytics !== undefined)
        {
            window.analytics.trackView('Meal Planners');
        }

    });

    $scope.showAllWeeksFromPlanners = function () {
        $state.go('app.all-planner-weeks');
    }
    
}])


.controller('PlannerController', ['$scope', '$http', '$state', '$ionicPopup', function ($scope, $http, $state, $ionicPopup) {
    
    $scope.myPlans = myMealPlans;
    var startText = '';
    var newPlanName;
    
    $scope.$on('$ionicView.enter', function(e) {
        
        if(typeof window.analytics !== undefined)
        {
            window.analytics.trackView('Your Meal Plans');
        }

        //$scope.checkForSignUp();

    });
    
    $scope.createPlan = function()
    {
        var newName = document.getElementById('planName').value;
        newName = toTitleCase(newName);
        var dup = false;
        
        // check name doesn't already exist
        
        for(var i=0;i<$scope.myPlans.length;i++)
        {
            if($scope.myPlans[i].Name==newName)
            {
                dup = true;
            }
        }
        
        newPlanName = newName;
        
        if((newPlanName.length>0)&&(!dup))
        {
            document.getElementById('planName').value = startText;
            loadNewRecipe();  
            
            document.activeElement.blur();
        }
        else if(dup)
        {
            
           
                     var alert = navigator.notification.alert(
                        'Your chosen meal planner name already exists, please choose another name.',  // message
                        alertDismissed,         // callback
                        'Name already exists',            // title
                        'Ok'                  // buttonName
                    );
            
            
            
        }
        else
        {
            
            
                     var alert = navigator.notification.alert(
                        'Please choose a name for your new meal planner.',  // message
                        alertDismissed,         // callback
                        'Choose a name',            // title
                        'Ok'                  // buttonName
                    );
            
            
        }

    }
    
    
    $scope.loadPlan = function(plan)
    { 
            currentPlan = plan;
            $state.go('app.your-plan');
    }
    
   function loadNewRecipe()
   {

            $http({
                method: 'GET',
                url: 'js/plans.json'
            }).then(function (response){

                $scope.plan = response.data.Plan;
                $scope.plan.Name = newPlanName;
                myMealPlans.push($scope.plan);
                
                $scope.updateData();
                window.analytics.trackEvent('Added', 'Custom Meal Planner', newPlanName);
            },function (error){
        
            });

        // $http.get('js/plans.json').success(function (data) {
            
        //    $scope.plan = data.Plan;
        //    $scope.plan.Name = newPlanName;
        //     myMealPlans.push($scope.plan);
            
        //     $scope.updateData();
        //     window.analytics.trackEvent('Added', 'Custom Meal Planner', newPlanName);
        // });
       
       
   }
    
    function toTitleCase(str)
    {
        return str.replace(/\w\S*/g, function(txt){return txt.charAt(0).toUpperCase() + txt.substr(1).toLowerCase();});
    }
    
    function alertDismissed()
    {
        
    }
    
    
}])

.controller('PlanController', ['$scope', '$http', '$state', '$ionicPopup', '$ionicHistory', function ($scope, $http, $state, $ionicPopup,$ionicHistory) {
   
   $scope.myPlans = myMealPlans;
   $scope.myPlan = currentPlan;
    
   $scope.mondayRecipes = currentPlan.Monday;
   $scope.tuesdayRecipes = currentPlan.Tuesday;
   $scope.wednesdayRecipes = currentPlan.Wednesday;
   $scope.thursdayRecipes = currentPlan.Thursday;
   $scope.fridayRecipes = currentPlan.Friday;
   $scope.saturdayRecipes = currentPlan.Saturday;
   $scope.sundayRecipes = currentPlan.Sunday;
    
    $scope.$on('$ionicView.enter', function(e) {
        
        if(typeof window.analytics !== undefined)
        {
            window.analytics.trackView('Custom Meal Plan');
        }

        //$scope.checkForSignUp();

    });
   
   $scope.showRecipe = function(rID,d,s)
   {
       
       if(dynamicallyAddedSlot)
       {
           currentSlot = currentPlan[d][s];
           currentSlot.id = currentRecipe.ArticleId;
           currentSlot.title = currentRecipe.Title;
           
           $scope.updateData();
           
           dynamicallyAddedSlot = false;
           
           
            var alert = navigator.notification.alert(
                'This recipe has been added to your meal planner',  // message
                alertDismissed,         // callback
                'Added to Meal Planner',            // title
                'Ok'                  // buttonName
            );

       }
       else
       {
           
           var p;
           
           if(rID>100)
           {
                for(var i=0;i<recipes.length;i++)
                {
                    if(recipes[i].ArticleId==rID)
                    {
                      p=recipes[i];  
                    }
                }

                // currentRecipe = p;
                // $state.go('app.recipe-details');  
                // window.analytics.trackEvent('View', 'Recipe', currentRecipe.ArticleId);

                if(registered)
                {
                    currentRecipe = p;
                    $state.go('app.recipe-details');
                    window.analytics.trackEvent('View', 'Recipe', currentRecipe.ArticleId);
                }
                else
                {
                    $scope.showPopUp('recipe list');
                }

           }
           else
           {
                $scope.pickRecipe(d,s);
           }
           
       }
    
   }
   
   $scope.removeRecipe = function(d,s)
   {
       currentPlan[d][s] = {"id":1,"title":"Add a recipe"};
       
       $scope.updateData();
   }
   
   $scope.pickRecipe = function(d,s)
   {
         if(!dynamicallyAddedSlot)
         {
               currentSlot = currentPlan[d][s];
               $scope.updateData();
               $state.go('app.plan-recipes');
               //$state.go('app.recipes-results');
         }
   }
   
   $scope.deletePlan = function(myPlan)
   {
       var alert = $ionicPopup.alert({
               
               title:'Delete plan',
               template:'Are you sure you would like to delete this meal plan',
               buttons: [
                   {
                       text:'Yes please',
                       onTap: function(e)
                       {
                           for(var p = 0;p<$scope.myPlans.length;p++) // check all favs
                            {
                                if(myPlan.Name==$scope.myPlans[p].Name)
                                {
                                    myMealPlans.splice(p,1);
                                    $scope.updateData();
                                }

                            } 
                           
                           $ionicHistory.goBack(-1);
                           return true;
                       }
                   },
                   {
                       text:'No thanks',
                       onTap: function(e)
                       {
                           return true;
                       }
                   }
               ]
           });
   }
   
    function alertDismissed()
    {
        
    }
   
    
}])

.controller('PlanRecipesController', ['$scope', '$http', '$state', '$ionicPopup', '$ionicHistory','$ionicScrollDelegate', function ($scope, $http, $state, $ionicPopup, $ionicHistory, $ionicScrollDelegate) {
   
   
    $scope.filteredRecipes = recipes; // all recipe
    $scope.displayMessage = false;
    $scope.items = [];
    var numberToAdd = 10;
    $scope.noResults = false;

    $scope.adEnvironment = env;

    $scope.noMoreItemsAvailable = false; // infinite scroll

    $scope.$on('$ionicView.enter', function(e) {
        
        if(filtering)
        {
            $scope.noMoreItemsAvailable = false;
            $ionicScrollDelegate.scrollTop();
            $scope.noResults = false;
            $scope.items = [];
            $scope.loadMore();
            filtering = false;
        }

        if(typeof window.analytics !== undefined)
        {
            window.analytics.trackView('Recipes List');
        }

    });

    if(filteredRecipes.length<1)
    {
        filteredRecipes = recipes;
    }
    
    $scope.noMoreItemsAvailable = false; // infinite scroll
    
    $scope.loadMore = function() {

        for(var i=0;i<numberToAdd;i++)
        {
            //alert($scope.items.length + ' vs ' + filteredRecipes.length)
            if ( $scope.items.length == filteredRecipes.length ) 
            {
              $scope.noMoreItemsAvailable = true;
            }
            else
            {
              $scope.items.push(filteredRecipes[$scope.items.length]);
            }

        }

        if($scope.items.length<1)
        {
            $scope.noResults = true;
        }
        else
        {
            $scope.noResults = false;
        }
        
        $scope.$broadcast('scroll.infiniteScrollComplete');

        $ionicScrollDelegate.resize(); 
      };
    
    
    $scope.selectRecipe = function (r) {
        currentSlot.id = r.ArticleId;
        currentSlot.title = r.Title;
        
        $scope.updateData();
        $state.go('app.your-plan');
    }

    $scope.filterRecipies = function(){
        
        $scope.items = [];
        $scope.showPopUp('plan-recipes');
    }
    
}])