'use strict';

angular.module('smaApp.view-recipe-details', [])

.config(function ($stateProvider, $urlRouterProvider) {
    $stateProvider
        .state('app.recipe-details', {
            url: '/recipe-details',
            views: {
                'menuContent': {
                    templateUrl: 'view-recipe-details/view-recipe-details.html',
                    controller: 'RecipeDetailController'
                }
            }
        })
})


.controller('RecipeDetailController', ['$scope', '$http', '$state', '$ionicPopup', function ($scope, $http, $state, $ionicPopup) {

    $scope.adEnvironment = env;
    $scope.favRecipes = favouriteRecipes;
    $scope.shopping = shoppingList;
    $scope.recipe = currentRecipe;
    $scope.recipeLabel = 'Recipe: '+currentRecipe.ArticleId;
    
    $scope.$on('$ionicView.enter', function(e) {
        
        $scope.recipe = currentRecipe;
        $scope.recipeLabel = 'Recipe: '+currentRecipe.ArticleId;
        
        //var l = 'Recipe: '+currentRecipe.ArticleId;
        
        if(typeof window.analytics !== undefined)
        {
            window.analytics.trackView('View Recipe');
            window.analytics.trackEvent('View', 'Recipe', $scope.recipeLabel);
        }

        // $scope.checkForSignUp();
        
    });

    $scope.GoBack = function () {
        $ionicHistory.goBack();
    };
    
    // MEAL PLANNER
    
    $scope.addToPlanner = function()
    {
        dynamicallyAddedSlot = true;
        $state.go('app.your-plans');
        
        if(typeof window.analytics !== undefined)
        {
            window.analytics.trackEvent('Added', 'Meal Planner', $scope.recipeLabel);
        }
    }
    
    //    FAVOURITES
    
    $scope.favouriteRecipe = function (e,aId) {
        
        // check status
        if($scope.checkFavourite(aId))
        {
            removeFavourite(aId);
        }
        else
        {
            addFavourite(aId);
        }
        
        $scope.updateData();
    }
    
    $scope.showPrep = function(i)
    {
        if(i.Prep!="")
        {
            return true;
        }
        else 
        {
            return false;
        }
    }
    
    
    $scope.checkFavourite = function(aId)
    {
        for(var f = 0;f<$scope.favRecipes.length;f++) // check all favs
        {
            if((aId==$scope.favRecipes[f].aId)&&($scope.favRecipes[f].fav))
            {
               return true;
            }
          
        }   
        
        return false;
    }
    
    function removeFavourite(aId)
    {
        for(var f = 0;f<favouriteRecipes.length;f++) // check all favs
        {
            if(aId==favouriteRecipes[f].aId)
            {
                if(favouriteRecipes[f].fav)
                    favouriteRecipes[f].fav=false;
            }
          
        } 
        
        var alert = navigator.notification.alert(
            'This recipe has been removed from your favourites list',  // message
                    alertDismissed,         // callback
                    'Removed from Favourites',            // title
                    'Ok'                  // buttonName
        );
    
        
        
    }
    
    function addFavourite(aId)
    {
        
        for(var f = 0;f<favouriteRecipes.length;f++) // check all favs
        {
            if(aId==favouriteRecipes[f].aId)
            {
                if(!favouriteRecipes[f].fav)
                    favouriteRecipes[f].fav=true;
            }
        } 

        var alert = navigator.notification.alert(
            'This recipe has been added to your favourites list',  // message
                    alertDismissed,         // callback
                    'Added to Favourites',            // title
                    'Ok'                  // buttonName     // buttonName
        );
        
        if(typeof window.analytics !== undefined)
        {
            window.analytics.trackEvent('Added', 'Favourites', $scope.recipeLabel);
        }
        
    }
    
    function alertDismissed()
    {
        
    }
    

}])