'use strict';

angular.module('smaApp.view-recipes-results', [])

.config(function ($stateProvider, $urlRouterProvider) {
    $stateProvider
        .state('app.recipes-results', {
            url: '/recipes-results',
            views: {
                'menuContent': {
                    templateUrl: 'view-recipes-results/view-recipes-results.html',
                    controller: 'RecipesController'
                }
            }
        })
})


.controller('RecipesController', ['$scope', '$http', '$state', '$ionicPopup', '$ionicScrollDelegate', function ($scope, $http, $state, $ionicPopup, $ionicScrollDelegate) {
    
    //$scope.filteredRecipes = recipes; // all recipe
    $scope.favRecipes = favouriteRecipes;
    $scope.displayMessage = false;
    $scope.items = [];
    var numberToAdd = 10;
    $scope.noResults = false;
    $scope.adEnvironment = env;
    
    $scope.$on('$ionicView.enter', function(e) {
        
        if(filtering)
        {
            $scope.noMoreItemsAvailable = false;
            $ionicScrollDelegate.scrollTop();
            $scope.noResults = false;
            $scope.items = [];
            $scope.loadMore();
            filtering = false;
        }

        if(typeof window.analytics !== undefined)
        {
            window.analytics.trackView('Recipes List');
        }

    });
    
    if(filteredRecipes.length<1)
    {
        filteredRecipes = recipes;
    }
    
    $scope.noMoreItemsAvailable = false; // infinite scroll
    
    $scope.loadMore = function() {
       
        for(var i=0;i<numberToAdd;i++)
        {
            //alert($scope.items.length + ' vs ' + filteredRecipes.length)
            if ( $scope.items.length == filteredRecipes.length ) 
            {
              $scope.noMoreItemsAvailable = true;
            }
            else
            {
              $scope.items.push(filteredRecipes[$scope.items.length]);
            }

        }
            
        if($scope.items.length<1)
        {
            $scope.noResults = true;
        }
        else
        {
            $scope.noResults = false;
        }
        
        $scope.$broadcast('scroll.infiniteScrollComplete');
        
        $ionicScrollDelegate.resize(); 
      };

    $scope.showRecipe = function (p) {
        
        //if(registered)
        //{
            currentRecipe = p;
            $state.go('app.recipe-details');
        //}
        //else
        //{
        //    $scope.showPopUp('recipe list');
        //}
    }
    
    $scope.favouriteRecipe = function (e,aId) {
        
        // check status
        if($scope.checkFavourite(aId))
        {
            removeFavourite(aId);
        }
        else
        {
            addFavourite(aId);
        }
        
        $scope.updateData();
    }
    
    
    $scope.checkFavourite = function(aId)
    {
        for(var f = 0;f<$scope.favRecipes.length;f++) // check all favs
        {
            if((aId==$scope.favRecipes[f].aId)&&($scope.favRecipes[f].fav))
            {
               return true;
            }
          
        }   
        
        return false;
    }

    $scope.filterRecipies = function(){
        
        $scope.items = [];
        $scope.showPopUp('recipes-results');
    }
    
    function removeFavourite(aId)
    {
        for(var f = 0;f<favouriteRecipes.length;f++) // check all favs
        {
            if(aId==favouriteRecipes[f].aId)
            {
                if(favouriteRecipes[f].fav)
                    favouriteRecipes[f].fav=false;
            }
          
        } 
    }
    
    function addFavourite(aId)
    {
        for(var f = 0;f<favouriteRecipes.length;f++) // check all favs
        {
            if(aId==favouriteRecipes[f].aId)
            {
                if(!favouriteRecipes[f].fav)
                    favouriteRecipes[f].fav=true;
            }
        } 
        
        if(typeof window.analytics !== undefined)
        {
            window.analytics.trackEvent('Added', 'Favourites', aId);
            
        }
    }


}])