'use strict';

angular.module('smaApp.view-shopping-list', [])

.config(function ($stateProvider, $urlRouterProvider) {
    $stateProvider
        .state('app.shopping', {
            url: '/shopping',
            views: {
                'menuContent': {
                    templateUrl: 'view-shopping-list/view-shopping-list.html',
                    controller: 'ShoppingController'
                }
            }
        })
})


.controller('ShoppingController', ['$scope', '$http', '$state', '$ionicPopup', '$ionicPopover', function ($scope, $http, $state, $ionicPopup, $ionicPopover) {

    $scope.shopping = shoppingList;

    $scope.$on('$ionicView.enter', function (e) {

        if (typeof window.analytics !== undefined) {
            window.analytics.trackView('Shopping List');
        }

    });

    $scope.removeItem = function (item) {

        shoppingList.splice(item, 1);
        $scope.updateData();
    }

    $scope.clearAllItems = function(){
        var alert = $ionicPopup.alert({
               
            title:'Clear all',
            template:'Are you sure you would like to delete all shopping items?',
            buttons: [
                {
                    text:'Yes please',
                    onTap: function(e)
                    {
                        removeAllItems();
                        return true;
                    }
                },
                {
                    text:'No thanks',
                    onTap: function(e)
                    {
                        
                        return true;
                    }
                }
            ]
        });
    }

    function removeAllItems() {
        shoppingList.splice(0, shoppingList.length);
        $scope.updateData();
    }
}])