'use strict';

angular.module('smaApp.view-week-planner', [])

.config(function ($stateProvider, $urlRouterProvider) {
    $stateProvider
        .state('app.all-weeks', {
            url: '/all-weeks',
            views: {
                'menuContent': {
                    templateUrl: 'view-week-planner/view-all-weeks.html',
                    controller: 'AllWeeks'
                }
            }
        })

        .state('app.all-planner-weeks', {
            url: '/all-planner-weeks',
            views: {
                'menuContent': {
                    templateUrl: 'view-week-planner/view-all-planner-weeks.html',
                    controller: 'AllPlannerWeeks'
                }
            }
        })

        .state('app.all-guide-weeks', {
            url: '/all-guide-weeks',
            views: {
                'menuContent': {
                    templateUrl: 'view-week-planner/view-all-guide-weeks.html',
                    controller: 'AllGuideWeeks'
                }
            }
        })
    
        .state('app.week-planner-week', {
            url: '/week-planner-week',
            views: {
                'menuContent': {
                    templateUrl: 'view-week-planner/view-week-planner.html',
                    controller: 'WeekPlannerController'
                }
            }
        })    

        .state('app.recipe-week-planner-week', {
            url: '/recipe-week-planner-week',
            views: {
                'menuContent': {
                    templateUrl: 'view-week-planner/view-recipe-week-planner.html',
                    controller: 'WeekPlannerController'
                }
            }
        })    

        .state('app.guide-week-planner-week', {
            url: '/guide-week-planner-week',
            views: {
                'menuContent': {
                    templateUrl: 'view-week-planner/view-guide-week-planner.html',
                    controller: 'WeekPlannerController'
                }
            }
        })    

})


.controller('AllWeeks', ['$scope', '$http', '$state', '$ionicPopup', function ($scope, $http, $state, $ionicPopup) {
    
    $scope.babyName = userBabyName;
    $scope.allWeeks = weekData;
    $scope.completed = completedWeeks;
    $scope.thisWeek = systemCalculatedWeek;
    
    $scope.$on('$ionicView.enter', function(e) {

        highlightCurrentWeek();
        $scope.thisWeek = systemCalculatedWeek;
        
        if(typeof window.analytics !== undefined)
        {
            window.analytics.trackView('Week By Week');
        }

    });

    $scope.showWeekDetails = function(index){
        //alert(index);
        if(index!==0)
        {
            currentWeekSelected = index;
            console.log('setting current week as');
            console.log(index);
            console.log(currentWeekSelected);
            $state.go('app.recipe-week-planner-week');
        }
    }

    $scope.showWeekPlannerDetails = function(index){
        //alert(index);
        if(index!==0)
        {
            currentWeekSelected = index;
            $state.go('app.week-planner-week');
        }
    }

    $scope.showWeekGuideDetails = function(index){
        //alert(index);
        if(index!==0)
        {
            currentWeekSelected = index;
            $state.go('app.guide-week-planner-week');
        }
    }
    

    function highlightCurrentWeek(){

        var wks = document.querySelectorAll('.week-box');
        for(var i = 0;i<wks.length-1;i++)
        {
            wks[i+1].getElementsByTagName('a')[0].classList.remove('week-current');
            wks[i+1].getElementsByTagName('a')[0].classList.remove('week-done');

            if((i+1) == systemCalculatedWeek)
            {
                wks[i+1].getElementsByTagName('a')[0].classList.add('week-current');
            }
            else if((i+1) < systemCalculatedWeek)
            {
                wks[i+1].getElementsByTagName('a')[0].classList.add('week-done');
            } 
        }

    }

}])

.controller('AllPlannerWeeks', ['$scope', '$http', '$state', '$ionicPopup', function ($scope, $http, $state, $ionicPopup) {
    
    $scope.babyName = userBabyName;
    $scope.allWeeks = weekData;
    $scope.completed = completedWeeks;
    $scope.thisWeek = systemCalculatedWeek;
    
    $scope.$on('$ionicView.enter', function(e) {

        highlightCurrentWeek();
        $scope.thisWeek = systemCalculatedWeek;
        
        if(typeof window.analytics !== undefined)
        {
            window.analytics.trackView('Week By Week');
        }

    });

    $scope.showWeekDetails = function(index){
        //alert(index);
        if(index!==0)
        {
            currentWeekSelected = index;
            $state.go('app.recipe-week-planner-week');
        }
    }

    $scope.showWeekPlannerDetails = function(index){
        //alert(index);
        if(index!==0)
        {
            currentWeekSelected = index;
            $state.go('app.week-planner-week');
        }
    }

    $scope.showWeekGuideDetails = function(index){
        //alert(index);
        if(index!==0)
        {
            currentWeekSelected = index;
            $state.go('app.guide-week-planner-week');
        }
    }

    function highlightCurrentWeek(){

        var wks = document.querySelectorAll('.week-planner-box');
        for(var i = 0;i<wks.length-1;i++)
        {
            wks[i+1].getElementsByTagName('a')[0].classList.remove('week-current');
            wks[i+1].getElementsByTagName('a')[0].classList.remove('week-done');

            if((i+1) == systemCalculatedWeek)
            {
                wks[i+1].getElementsByTagName('a')[0].classList.add('week-current');
            }
            else if((i+1) < systemCalculatedWeek)
            {
                wks[i+1].getElementsByTagName('a')[0].classList.add('week-done');
            } 
        }

    }

}])

.controller('AllGuideWeeks', ['$scope', '$http', '$state', '$ionicPopup', function ($scope, $http, $state, $ionicPopup) {
    
    $scope.babyName = userBabyName;
    $scope.allWeeks = weekData;
    $scope.completed = completedWeeks;
    $scope.thisWeek = systemCalculatedWeek;
    
    $scope.$on('$ionicView.enter', function(e) {

        highlightCurrentWeek();
        $scope.thisWeek = systemCalculatedWeek;
        
        if(typeof window.analytics !== undefined)
        {
            window.analytics.trackView('Week By Week');
        }

    });

    $scope.showWeekDetails = function(index){
        //alert(index);
        if(index!==0)
        {
            currentWeekSelected = index;
            $state.go('app.recipe-week-planner-week');
        }
    }

    $scope.showWeekPlannerDetails = function(index){
        //alert(index);
        if(index!==0)
        {
            currentWeekSelected = index;
            $state.go('app.week-planner-week');
        }
    }

    $scope.showWeekGuideDetails = function(index){
        //alert(index);
        if(index!==0)
        {
            currentWeekSelected = index;
            $state.go('app.guide-week-planner-week');
        }
    }

    function highlightCurrentWeek(){

        var wks = document.querySelectorAll('.week-guide-box');
        for(var i = 0;i<wks.length-1;i++)
        {
            wks[i+1].getElementsByTagName('a')[0].classList.remove('week-current');
            wks[i+1].getElementsByTagName('a')[0].classList.remove('week-done');

            if((i+1) == systemCalculatedWeek)
            {
                wks[i+1].getElementsByTagName('a')[0].classList.add('week-current');
            }
            else if((i+1) < systemCalculatedWeek)
            {
                wks[i+1].getElementsByTagName('a')[0].classList.add('week-done');
            } 
        }

    }

}])

.controller('WeekPlannerController', ['$scope', '$http', '$state', '$ionicPopup', '$ionicTabsDelegate', '$timeout', '$ionicScrollDelegate', function ($scope, $http, $state, $ionicPopup, $ionicTabsDelegate, $timeout,$ionicScrollDelegate) {
    
    //$scope.wk = $state.params.wId;
    $scope.wk = currentWeekSelected;
    $scope.popover;
    
    $scope.filteredRecipes = recipes;
    
    $scope.dictionary = recipeDict;

    $scope.favRecipes = favouriteRecipes;
    
    $scope.completed = completedWeeks;

    //$ionicTabsDelegate.select(2, false); // revert to the planner tab

    $scope.adEnvironment = env;

    $scope.$on('$stateChangeStart', 
   function (event, toState, toParams, fromState, fromParams) {


       console.log('toState');
       console.dir(fromState);
       console.log('fromState');
       console.dir(toState);

    //    var stateSection = fromState.url.split("/");
    //    console.dir(stateSection[1]);

       if(toState.url == '/all-weeks')
       {
            $ionicTabsDelegate.select(0, false); // revert to the first tab
       }
       else if(toState.url == '/all-planner-weeks')
       {
            $ionicTabsDelegate.select(0, false); // revert to the first tab
       }
       else if(toState.url == '/all-guide-weeks')
       {
            $ionicTabsDelegate.select(0, false); // revert to the first tab
       }
       else if(toState.url == '/home')
       {
            $ionicTabsDelegate.select(0, false); // revert to the first tab
       }
       else if(toState.url == '/weaning-guide')
       {
            $ionicTabsDelegate.select(0, false); // revert to the first tab
       }
       else if(toState.url == '/planners')
       {
            $ionicTabsDelegate.select(0, false); // revert to the first tab
       }

       //if((stateSection[1]!='weaning-guide') && (stateSection[1]!='recipe-details'))
       //{
            // $scope.wk = currentWeekSelected;
            // console.log('current week is:');
            // console.dir(currentWeekSelected);
        //}

   })
    
    $scope.$on('$ionicView.enter', function(e) {
    
        $scope.wk = currentWeekSelected;

        updatePage();

        if(typeof window.analytics !== undefined)
        {
            window.analytics.trackView('Week Info');
            window.analytics.trackEvent('View', 'Week', $scope.wk);
        }

    });
    
    $scope.selectTabs = function(index) { // sorts the scrolling issue
        $ionicTabsDelegate.select(index);
        $ionicScrollDelegate.resize();   
        
    }
    
    $scope.openGuideLink = function(url)
    {
        var u = 'app.'+url;
        $state.go(u);
    }
    
    $scope.goBackAWeek = function()
    {
        if($scope.wk>1)
        {
            $scope.wk--;
            currentWeekSelected =  $scope.wk;
        }
        
        updateArrows();
        updatePage();
    }
    
    $scope.goForwardAWeek = function()
    {
        if($scope.wk<26)
        {
            $scope.wk++;
            currentWeekSelected =  $scope.wk;
        }

        updateArrows();
        updatePage();
    }
    
    function updateArrows()
    {
        if($scope.wk<2)
            document.getElementsByClassName('back-button-left')[0].style.opacity = '0.5';
        else
            document.getElementsByClassName('back-button-left')[0].style.opacity = '1';
        
        if($scope.wk>25)
            document.getElementsByClassName('back-button-right')[0].style.opacity = '0.5';
        else
            document.getElementsByClassName('back-button-right')[0].style.opacity = '1';
    }
    
    function updatePage()
    {
        $scope.theWeek = weekData[$scope.wk];
        $scope.theWeeksMeals = weekData[$scope.wk].MealPlanner;
        $scope.theWeeksLinks = $scope.theWeek.GuideContent;
       

        for(var i=0;i<$scope.theWeek.GuideContent.length;i++)
        {
            console.log(i);
            console.log($scope.theWeek.GuideContent[i].LinkTitle)
            var tit = $scope.theWeek.GuideContent[i].LinkTitle;
            var newTit = tit.replace(/your baby/gi, userBabyName);
            newTit = newTit.replace(/my baby/gi, userBabyName);
            $scope.theWeek.GuideContent[i].LinkTitle = newTit;
        }

        $ionicScrollDelegate.resize();
    }
    
    $scope.addToShoppingList = function(day)
    {
        
            var dayNo=0;
            var mealList=[];
            var ingredientList=[];

            switch(day)
            {
                case 'Monday':dayNo=0; break;
                case 'Tuesday':dayNo=1; break;
                case 'Wednesday':dayNo=2; break;
                case 'Thursday':dayNo=3; break;
                case 'Friday':dayNo=4; break;
                case 'Saturday':dayNo=5; break;
                case 'Sunday':dayNo=6; break;
            }

            // get the day object

            var daysMeals = $scope.theWeeksMeals[dayNo];

            // search it for the meal codes

            var breakfastMeals = daysMeals.Breakfast;
            var lunchMeals = daysMeals.Lunch;
            var teaMeals = daysMeals.Tea;

            if(breakfastMeals!=undefined)
            {
                for(var i=0;i<breakfastMeals.length;i++)
                {
                    if(breakfastMeals[i].id>100)
                    {
                        mealList.push(breakfastMeals[i].id);
                    }
                }
            }

            if(teaMeals!=undefined)
            {
                for(var i=0;i<teaMeals.length;i++)
                {
                    if(teaMeals[i].id>100)
                    {
                        mealList.push(teaMeals[i].id);
                    }
                }
            }

            if(lunchMeals!=undefined)
            {
                for(var i=0;i<lunchMeals.length;i++)
                {
                    if(lunchMeals[i].id>100)
                    {
                        mealList.push(lunchMeals[i].id);
                    }
                }
            }


            // for each meal code get the indredients array

            for(var r=0;r<recipes.length;r++)
            {
                for(var m=0;m<mealList.length;m++)
                {

                    if(recipes[r].ArticleId==mealList[m])
                    {
                         console.log('added');
                         ingredientList.push(recipes[r].Ingredients.Ingredient);
                    }

                }
            }

            // add the ingredients arrays to the shoppingList (while checking for dupes)

            for(i=0;i<ingredientList.length;i++)
            {
                console.log('pushed');
                addToList(ingredientList[i]);
            }
            
            $scope.updateData();
            
            var msg = day+"'s ingredients have been added to your shopping list";
            
            
                    var alert = navigator.notification.alert(
                        msg,  // message
                        alertDismissed,         // callback
                        'Added to Shopping List',            // title
                        'Ok'                  // buttonName
                    );
        
    }
    
    
    function addToList(ing)
    {
        // 1st check to see if the indredients already exist in the shopping list
        
        for(var s=0;s<shoppingList.length;s++)
        {
            for(var i=0;i<ing.length;i++)
            {
                if(shoppingList[s].Title==ing[i].Title) // if they do alter the existing item
                {
                    var origVal = parseFloat(shoppingList[s].Amount)
                    var newVal = parseFloat(ing[i].Amount);
                    shoppingList[s].Amount = (origVal+newVal);
                    ing.splice(i,1); // remove from new list
                }
            }
        }
        
        // 2nd add any remaining items to the shopping list
        
        for(i=0;i<ing.length;i++)
        {
            shoppingList.push(ing[i]);
        }
        
    }
    
    $scope.weekFilter = function (item){
        
        $scope.theWeeksRecipes = weekData[$scope.wk].RecipeList;
        
        for(var i=0;i<$scope.theWeeksRecipes.length;i++)
        {
            if($scope.theWeeksRecipes[i]==item.ArticleId)
            {
                return true;
            }
        }
        
        return false;
    }
    
    $scope.clickRecipe = function(item) 
    {
        
        if(item.id>100)
        {
            for(var r=0;r<recipes.length;r++)
            {
                if(recipes[r].ArticleId==item.id)
                {
                    $scope.showRecipe(recipes[r]);
                }
            }
        }
    }

    $scope.showRecipe = function (p) {
        
        currentRecipe = p;
        $state.go('app.recipe-details');
        
        if(typeof window.analytics !== undefined)
        {
            window.analytics.trackEvent('View', 'Recipe', currentRecipe.ArticleId);
        }
    }
    
    $scope.favouriteRecipe = function (e,aId) {
        
        // check status
        if($scope.checkFavourite(aId))
        {
            removeFavourite(aId);
        }
        else
        {
            addFavourite(aId);
        }
        
        $scope.updateData();
    }
    
    
    $scope.checkFavourite = function(aId)
    {
        for(var f = 0;f<$scope.favRecipes.length;f++) // check all favs
        {
            if((aId==$scope.favRecipes[f].aId)&&($scope.favRecipes[f].fav))
            {
               return true;
            }
          
        }   
        
        return false;
    }
    
    function removeFavourite(aId)
    {
        for(var f = 0;f<favouriteRecipes.length;f++) // check all favs
        {
            if(aId==favouriteRecipes[f].aId)
            {
                if(favouriteRecipes[f].fav)
                    favouriteRecipes[f].fav=false;
            }
          
        } 
    }
    
    function addFavourite(aId)
    {
        for(var f = 0;f<favouriteRecipes.length;f++) // check all favs
        {
            if(aId==favouriteRecipes[f].aId)
            {
                if(!favouriteRecipes[f].fav)
                    favouriteRecipes[f].fav=true;
            }
        } 
        
        if(typeof window.analytics !== undefined)
        {
            window.analytics.trackEvent('Added', 'Favourites', aId);
        }
    }
    
    $scope.showArrow = function(id)
    {
        if(id>100)
            return true;
        else
            return false;
    }
    
    $scope.showTitle = function(v)
    {
        if(v!=null)
            return true;
        else
            return false;
    }
    
    $scope.showWaking = function(w)
    {
        if(w.length>0)
            return true;
        else
            return false;
    }

}])

