'use strict';

angular.module('smaApp.welcome', [])

.config(function ($stateProvider, $urlRouterProvider) {
    $stateProvider
        .state('app.welcome', {
            url: '/welcome',
            views: {
                'menuContent': {
                    templateUrl: 'view-welcome/view-welcome.html',
                    controller: 'WelcomeController'
                }
            }
        })

        .state('app.welcome-back', {
            url: '/welcome-back',
            views: {
                'menuContent': {
                    templateUrl: 'view-welcome/view-welcome-back.html',
                    controller: 'WelcomeBackController'
                }
            }
        })
})

.controller('WelcomeController', ['$scope', '$http', '$state', '$ionicPopup', '$ionicPopover', function ($scope, $http, $state, $ionicPopup,$ionicPopover) {

    $scope.babyName = userBabyName;
    //$scope.thisWeek = systemCalculatedWeek;
    $scope.displayedWeek = systemCalculatedWeek;
    $scope.thisWeekMinus1;
    $scope.thisWeekMinus2;
    $scope.thisWeekPlus1;
    $scope.thisWeekPlus2;

    $scope.weekAboveZero = false;
    $scope.weekAboveTwentySix = false;

    console.log('week is');
    console.log(systemCalculatedWeek);

    if(systemCalculatedWeek > 0)
    {
        $scope.weekAboveZero = true;
    }

    if(systemCalculatedWeek == 27)
    {
        $scope.weekAboveZero = true;
        $scope.weekAboveTwentySix = true;
    }

    $scope.weekHighlight = weekHighlights[systemCalculatedWeek].replace(/babyname/gi, userBabyName);                         
    //setWeekWidgetNumbers();
        
    $scope.$on('$ionicView.enter', function(e) {

        $scope.babyName = userBabyName;
        $scope.thisWeek = systemCalculatedWeek;
        $scope.weekHighlight = weekHighlights[systemCalculatedWeek].replace(/babyname/gi, userBabyName);
        $scope.displayedWeek = systemCalculatedWeek;

        if(systemCalculatedWeek > 1)
        {
            $scope.weekAboveZero = true;
        }
        
        // if(typeof window.analytics !== undefined)
        // {
        //     window.analytics.trackView('Welcome');
        // }

        if(filteredRecipes.length<1)
        {
            $scope.noResults = true;
            filteredRecipes = recipes;
        }

        if(systemCalculatedWeek > 0)
        {
            $scope.weekAboveZero = true;
        }
        else{
            $scope.weekAboveZero = false;
        }

        if(systemCalculatedWeek == 27)
        {
            $scope.weekAboveZero = true;
            $scope.weekAboveTwentySix = true;
        }
        else
        {
            $scope.weekAboveTwentySix = false;
        }

    });

    $scope.reduceWeekNumber = function(){
        

        if($scope.displayedWeek>1)
        {
            $scope.unsavedChanges = true;
            $scope.unsavedChangesWeek = true;
            $scope.displayedWeek--;
            updateHighlight($scope.displayedWeek);
        }

        if($scope.displayedWeek == systemCalculatedWeek)
        {
            $scope.unsavedChanges = false;
            $scope.unsavedChangesWeek = false;
        }
    }

    $scope.increaseWeekNumber = function(){
        if($scope.displayedWeek<27)
        {
            $scope.unsavedChanges = true;
            $scope.unsavedChangesWeek = true;
            $scope.displayedWeek++;
            updateHighlight($scope.displayedWeek);
        }

        if($scope.displayedWeek == systemCalculatedWeek)
        {
            $scope.unsavedChanges = false;
            $scope.unsavedChangesWeek = false;
        }
    }

    function updateHighlight(w)
    {
        $scope.weekHighlight = weekHighlights[w].replace(/babyname/gi, userBabyName);

        if($scope.displayedWeek == 27)
        {
            $scope.weekAboveTwentySix = true;
        }
        else
        {
            $scope.weekAboveTwentySix = false;
        }
    }

    $scope.saveAndGetStarted = function()
    {
        $scope.updateBabyProfile(userBabyName, userBabyDOB, $scope.displayedWeek);
    }
    
}])

// .controller('WelcomeController', ['$scope', '$http', '$state', '$ionicPopup', '$ionicPopover', function ($scope, $http, $state, $ionicPopup,$ionicPopover) {

//     $scope.babyName = userBabyName;
//     //$scope.thisWeek = systemCalculatedWeek;
//     $scope.displayedWeek = systemCalculatedWeek;
//     $scope.thisWeekMinus1;
//     $scope.thisWeekMinus2;
//     $scope.thisWeekPlus1;
//     $scope.thisWeekPlus2;

//     $scope.weekAboveZero = false;

//     console.log('week is');
//     console.log(systemCalculatedWeek);

//     if(systemCalculatedWeek > 1)
//     {
//         $scope.weekAboveZero = true;
//     }

//     $scope.weekHighlight = weekHighlights[systemCalculatedWeek].replace(/babyname/gi, userBabyName);                         
//     //setWeekWidgetNumbers();
        
//     $scope.$on('$ionicView.enter', function(e) {

//         $scope.babyName = userBabyName;
//         $scope.thisWeek = systemCalculatedWeek;
//         $scope.weekHighlight = weekHighlights[systemCalculatedWeek].replace(/babyname/gi, userBabyName);

//         if(systemCalculatedWeek > 1)
//         {
//             $scope.weekAboveZero = true;
//         }
        
//         if(typeof window.analytics !== undefined)
//         {
//             window.analytics.trackView('Home Screen');
//         }

//         if(filteredRecipes.length<1)
//         {
//             $scope.noResults = true;
//             filteredRecipes = recipes;
//         }

//     });

//     $scope.reduceWeekNumber = function(){
        

//         if($scope.displayedWeek>1)
//         {
//             $scope.unsavedChanges = true;
//             $scope.unsavedChangesWeek = true;
//             $scope.displayedWeek--;
//             updateHighlight($scope.displayedWeek);
//         }

//         if($scope.displayedWeek == systemCalculatedWeek)
//         {
//             $scope.unsavedChanges = false;
//             $scope.unsavedChangesWeek = false;
//         }
//     }

//     $scope.increaseWeekNumber = function(){
//         if($scope.displayedWeek<26)
//         {
//             $scope.unsavedChanges = true;
//             $scope.unsavedChangesWeek = true;
//             $scope.displayedWeek++;
//             updateHighlight($scope.displayedWeek);
//         }

//         if($scope.displayedWeek == systemCalculatedWeek)
//         {
//             $scope.unsavedChanges = false;
//             $scope.unsavedChangesWeek = false;
//         }
//     }

//     function updateHighlight(w)
//     {
//         $scope.weekHighlight = weekHighlights[w].replace(/babyname/gi, userBabyName);
//     }

//     $scope.saveAndGetStarted = function()
//     {
//         $scope.updateBabyProfile(userBabyName, userBabyDOB, $scope.displayedWeek);
//     }
    
// }])

.controller('WelcomeBackController', ['$scope', '$http', '$state', '$ionicPopup', '$ionicPopover', function ($scope, $http, $state, $ionicPopup,$ionicPopover) {

    $scope.babyName = userBabyName;
    //$scope.thisWeek = systemCalculatedWeek;
    $scope.displayedWeek = systemCalculatedWeek;
    $scope.thisWeekMinus1;
    $scope.thisWeekMinus2;
    $scope.thisWeekPlus1;
    $scope.thisWeekPlus2;
    //$scope.weekAboveTwentySix = false;

    console.log('week is');
    console.log(systemCalculatedWeek);

    if(systemCalculatedWeek > 1)
    {
        $scope.weekAboveZero = true;
    }

    // if(systemCalculatedWeek > 25)
    // {
    //     $scope.weekAboveZero = true;
    //     $scope.weekAboveTwentySix = true;
    // }

    $scope.weekHighlight = weekHighlights[systemCalculatedWeek].replace(/babyname/gi, userBabyName);                         
    //setWeekWidgetNumbers();
        
    $scope.$on('$ionicView.enter', function(e) {

        $scope.babyName = userBabyName;
        $scope.thisWeek = systemCalculatedWeek;
        $scope.weekHighlight = weekHighlights[systemCalculatedWeek].replace(/babyname/gi, userBabyName);

        if(systemCalculatedWeek > 1)
        {
            $scope.weekAboveZero = true;
        }
        
        if(typeof window.analytics !== undefined)
        {
            window.analytics.trackView('Welcome Back');
        }

        if(filteredRecipes.length<1)
        {
            $scope.noResults = true;
            filteredRecipes = recipes;
        }

    });

    $scope.reduceWeekNumber = function(){
        

        if($scope.displayedWeek>1)
        {
            $scope.unsavedChanges = true;
            $scope.unsavedChangesWeek = true;
            $scope.displayedWeek--;
            updateHighlight($scope.displayedWeek);
        }

        if($scope.displayedWeek == systemCalculatedWeek)
        {
            $scope.unsavedChanges = false;
            $scope.unsavedChangesWeek = false;
        }
    }

    $scope.increaseWeekNumber = function(){
        if($scope.displayedWeek<26)
        {
            $scope.unsavedChanges = true;
            $scope.unsavedChangesWeek = true;
            $scope.displayedWeek++;
            updateHighlight($scope.displayedWeek);
        }

        if($scope.displayedWeek == systemCalculatedWeek)
        {
            $scope.unsavedChanges = false;
            $scope.unsavedChangesWeek = false;
        }
    }

    function updateHighlight(w)
    {
        $scope.weekHighlight = weekHighlights[w].replace(/babyname/gi, userBabyName);
    }

    $scope.saveAndGetStarted = function()
    {
        $scope.updateBabyProfile(userBabyName, userBabyDOB, $scope.displayedWeek);
    }
    
}])